Subject: bug#30429: 27.0.50; Emacs TERMINFO "xterm-direct" "efaq" example not working

From: Eli Zaretskii <[email-masked]>
Date: Mon, 12 Feb 2018 17:51:09 +0200

> From: Live System User <[email-masked]>
> Date: Sun, 11 Feb 2018 21:09:40 -0500
> 
>         The example in the "efaq" Info file gives the following
> 
>                 TERM=xterm-direct emacs -nw
> 
>         When I execute this, as stated, I get an Emacs session
>         WITHOUT any colors -- even "M-x list-colors-display"
>         does not show any colors.
> 
>         However, if I change this to the following, I see colors
>         displayed:
> 
>                 TERM=xterm-direct2 emacs -nw
> 
>         [Note the "2" in "xterm-drect2"]
> 
>         Here is the definition for the setab/setaf parameters for
>         each:
> 
> 
> 
> xterm-direct2:
> 
> # Emacs 26.1 and later support direct color mode in terminals, using a
> # combination of user-defined capabilities and ncurses-dependent function
> # calls.  We will not include that here.
> #
> # Here is a first revision, which (disregarding the reuse of colors 1-7 which
> # is of interest only to the numerically illiterate), is compatible with other
> # terminal descriptions written for curses.  It relies upon the extended range
> # for numeric capabilities provided in ncurses 6.1:
> xterm+direct2|xterm with direct-color indexing,
> [...]
> 
> xterm-direct2|xterm with direct-color indexing (old),
> 	use=xterm+direct2, use=xterm+titlestack, use=xterm,
> [...]
> 	setab=\E[%?%p1%{8}%<%t4%p1%d%e48\:2\:%p1%{65536}%/%d\:%p1%{256}%/%{255}%&%d\:%p1%{255}%&%d%;m,
> 	setaf=\E[%?%p1%{8}%<%t3%p1%d%e38\:2\:%p1%{65536}%/%d\:%p1%{256}%/%{255}%&%d\:%p1%{255}%&%d%;m,
> 
> 
> 
> 
> 
> xterm-direct:
> 
> # That in turn had a problem: in the original patch submitted for KDE konsole
> # in 2006, the submitter and the developer alike overlooked a "color space
> # identifier" parameter.  This version provides for that parameter:
> xterm+direct|xterm with direct-color indexing,
> [...]
> 	setab=\E[%?%p1%{8}%<%t4%p1%d%e48\:2\:\:%p1%{65536}%/%d\:%p1%{256}%/%{255}%&%d\:%p1%{255}%&%d%;m,
> 	setaf=\E[%?%p1%{8}%<%t3%p1%d%e38\:2\:\:%p1%{65536}%/%d\:%p1%{256}%/%{255}%&%d\:%p1%{255}%&%d%;m,
> 
> 
> 
> 
> 
> 
>        Between the two ("xterm-direct"and "xerm-direct2"), I see
>        the diffeence in at least "\:2\:\:" and "\:2\:".
>        respectively -- "xterm-direct" has an additioal "\:"
> 
> 
> 
> 
>        So, should Emacs be changed to accommadate the missing
>        parameter ("\:" as in "xterm-direct")??
> 
>        Or should the information in "efaq" be changed to specify
>        "xterm-direct2"?
> 
>        Or...?
> 
>        Can anyone else confirm that colors are not displayed
>        in Emacs TTY when using TERMINFO's 6.1 definition of
>        "xterm-direct" (setab/setaf)?

Thanks for reporting this.

Rami, could you please take a look?